%define rhugversion 20030415
%define rhugsource1 __flat__ upstream
%define rhugprep1 find -name '*.class' | xargs rm

Summary: Parser Generator for Java
Name: cup
Version: v10k
Release: 10
URL: http://www.cs.princeton.edu/~appel/modern/java/CUP/
Source: rhug-%{name}-%{rhugversion}.tar.bz2
Source1: java_%{name}_%{version}.tar.gz
Patch1: %{name}-v10k-release.patch
Patch2: %{name}-v10k-version.patch
Patch3: %{name}-v10k-relink.patch
Patch4: %{name}-v10k-hammer.patch
License: MPL
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: gcc-c++-ssa
BuildPrereq: gcc-java-ssa >= 3.5ssa-0.20030801.34
Prereq: redhat-java-rpm-scripts >= 1.0.2-2
Requires: libgcj-ssa >= 3.5ssa-0.20030801.34
ExclusiveArch: i386 x86_64 ppc ia64

%description
CUP is a system for generating LALR parsers from simple
specifications. It serves the same role as the widely used program
YACC and in fact offers most of the features of YACC. However, CUP is
written in Java, uses specifications including embedded Java code, and
produces parsers which are implemented in Java.

%package devel
Summary: CNI headers for developing CUP applications
Group: Development/Libraries
Requires: cup = %{version}-%{release}

%description devel
The cup-devel package contains the headers required to develop
Cygnus Native Interface (CNI) extensions that use CUP.

%prep
%setup -q
mkdir upstream
(cd upstream && tar xfz %{SOURCE1} && %{rhugprep1})
%patch1 -p0 -b .release
%patch2 -p0 -b .version
%patch3 -p0 -b .relink
%patch4 -p0 -b .hammer
mv ChangeLog ChangeLog.rhug

%build
CC=gcc-ssa CXX=g++-ssa GCJ=gcj-ssa GCJH=gcjh-ssa \
./configure --disable-static --prefix=%{_prefix} --libdir=%{_libdir}
make

%install
rm -rf ${RPM_BUILD_ROOT}
%makeinstall
rm -f ${RPM_BUILD_ROOT}%{_libdir}/*.la
find ${RPM_BUILD_ROOT}%{_libdir} -type l | xargs rm -f
for f in java_cup; do
  mv ${RPM_BUILD_ROOT}%{_bindir}/$f ${RPM_BUILD_ROOT}%{_bindir}/$f-10.11
done

%post
%{_sbindir}/javaconfig \
    %{_bindir}/java_cup \
    %{_libdir}/lib-java_cup.so \
    %{_libdir}/lib-java_cup-runtime.so \
    %{_datadir}/java/java_cup.jar

%postun
%{_sbindir}/javaconfig \
    %{_bindir}/java_cup \
    %{_libdir}/lib-java_cup.so \
    %{_libdir}/lib-java_cup-runtime.so \
    %{_datadir}/java/java_cup.jar

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc *.rhug upstream/[CILR]* upstream/*.{html,gif}
%{_bindir}/*
%{_libdir}/*.so
%{_datadir}/java/*.jar

%files devel
%defattr(-,root,root)
%{_includedir}/java_cup

%changelog
* Fri Sep  5 2003 Gary Benson <gbenson@redhat.com> v10k-10
- Ensure we have a working javaconfig.

* Thu Sep  4 2003 Gary Benson <gbenson@redhat.com>
- Remove workarounds used to support alpha releases.

* Fri Aug 15 2003 Gary Benson <gbenson@redhat.com> v10k-9
- Rebuild with new compiler.

* Tue Aug  5 2003 Gary Benson <gbenson@redhat.com> v10k-8
- Rebuild with new compiler.

* Fri Jul 25 2003 Gary Benson <gbenson@redhat.com> v10k-7
- Move everything but the CNI includes out of the -devel subpackage.
- Clarify the -devel subpackage's summary and description.
- Remove unnecessary -devel build-time dependencies (#99077).

* Mon Jun 30 2003 Gary Benson <gbenson@redhat.com> v10k-6
- Rebuild with new compiler and enable ia64 build.

* Fri Jun  6 2003 Gary Benson <gbenson@redhat.com> v10k-5
- Rebuild with new compiler.

* Thu Jun  5 2003 Gary Benson <gbenson@redhat.com>
- Add build time dependency on C++ compiler.

* Thu May 29 2003 Gary Benson <gbenson@redhat.com> v10k-4
- Rebuild with new compiler.

* Thu May 22 2003 Gary Benson <gbenson@redhat.com> v10k-3
- Move non-runtime library into -devel subpackage.
- Move unversioned library symlink into main package.

* Sat May  3 2003 Gary Benson <gbenson@redhat.com> v10k-2
- Rebuild with new compiler.

* Thu Apr 24 2003 Gary Benson <gbenson@redhat.com> v10k-1
- Initial Red Hat Linux build.

* Thu Apr 24 2003 Gary Benson <gbenson@redhat.com>
- Upgrade to latest version.

* Sat Mar  2 2002 Anthony Green <green@redhat.com>
- Initial RHUG build.
